gxditview(1)

Name
gxditview - display groff intermediate output files in X11

Synopsis
gxditview [X-toolkit-option ...] [-backingStore backing-store-type] [-filename file] [-page page-number] [-printCommand command] [-resolution resolution] file
gxditview -help
gxditview --help
gxditview -version
gxditview --version

Description
gxditview interprets and displays the intermediate output format of groff(1) on an X11 display. It uses the standard X11 fonts, so it does not require access to the server machine for font loading. There are several ways to use gxditview.

The intermediate output format of groff, documented in groff_out(5), is produced by gtroff or the -Z option to groff. It can be viewed by explicitly calling “gxditview file”. If the file operand is “-”, gxditview will read the standard input stream; file cannot be omitted. The intermediate output format of groff is device-independent but not device-agnostic. gxditview can view it for all typesetter devices, but the quality is device-dependent. gxditview will not display output for terminal (nroff) devices.

The best results are achieved with the X* devices for groff's -T option, of which there are four: -TX75, -TX75-12, -TX100, and -TX100-12. They differ by the X resolution (75 or 100 dots per inch) and the base point size (10 or 12 points). They are especially built for gxditview. When using one of these, groff generates the intermediate output for this device and calls gxditview automatically for viewing.

-X produces good results only with -Tps, -TX75, -TX75-12, -TX100, and -TX100-12. The default resolution for previewing -Tps output is 75dpi; this can be changed with the -resolution option.

While gxditview is running, the left mouse button brings up a menu with several entries.

Next Page
    Display the next page.

Previous Page
    Display the previous page.

Select Page
    Select a particular numbered page specified by a dialog box.

Print
    Print the groff intermediate output using a command specified by a dialog box. The default command initially displayed is controlled by the printCommand application resource, and by the -printCommand option.

Open
    Open for display a new file specified by a dialog box. The file should contain groff intermediate output. If the filename starts with a bar or pipe symbol, “|” it will be interpreted as a command from which to read.

Quit
    Exit from gxditview.

The menu entries correspond to actions with similar but not identical names, which can also be accessed with keyboard accelerators. The n, Space, Return, and Next (PgDn) keys are bound to the NextPage action. The p, b, BackSpace, Delete, and Prior (PgUp) keys are bound to the PreviousPage action. The g key is bound to the SelectPage action. The o key is bound to the OpenFile action. The q key is bound to the Quit action. The r key is bound to a Rerasterize action which rereads the current file, and redisplays the current page; if the current file is a command, the command will be re-executed. Vertical scrolling can be done with the k and j keys; horizontal scrolling is bound to the h and l keys. The arrow keys (up, down, left, and right) are also bound to the obvious scrolling actions.

The paperlength and paperwidth commands in the DESC file describing a groff output device specify the length and width in machine units of the virtual page displayed by gxditview; see groff_font(5).

  X defaults
This program uses the Dvi widget from the X Toolkit. It understands all of the core resource names and classes as well as:

width (class Width)
    Specifies the width of the window.

height (class Height)
    Specifies the height of the window.

foreground (class Foreground)
    Specifies the default foreground color.

font (class Font)
    Specifies the font to be used for error messages.

fontMap (class FontMap)
    Specifies the mapping from groff font names to X font names. This must be a string containing a sequence of lines. Each line contains two whitespace-separated fields: firstly the groff font name, and secondly the XLFD (X Logical Font Description). The default is shown in subsection “Default font map” below.

  Default font map
XLFDs are long and unwieldy, so some lines are shown broken and indented below.

    TR  -adobe-times-medium-r-normal--*-100-*-*-*-*-iso8859-1\n\
    TI  -adobe-times-medium-i-normal--*-100-*-*-*-*-iso8859-1\n\
    TB  -adobe-times-bold-r-normal--*-100-*-*-*-*-iso8859-1\n\
    TBI -adobe-times-bold-i-normal--*-100-*-*-*-*-iso8859-1\n\
    CR  -adobe-courier-medium-r-normal--*-100
            -*-*-*-*-iso8859-1\n\
    CI  -adobe-courier-medium-o-normal
            --*-100-*-*-*-*-iso8859-1\n\
    CB  -adobe-courier-bold-r-normal--*-100-*-*-*-*-iso8859-1\n\
    CBI -adobe-courier-bold-o-normal--*-100-*-*-*-*-iso8859-1\n\
    HR  -adobe-helvetica-medium-r-normal
            --*-100-*-*-*-*-iso8859-1\n\
    HI  -adobe-helvetica-medium-o-normal
            --*-100-*-*-*-*-iso8859-1\n\
    HB  -adobe-helvetica-bold-r-normal
            --*-100-*-*-*-*-iso8859-1\n\
    HBI -adobe-helvetica-bold-o-normal
            --*-100-*-*-*-*-iso8859-1\n\
    NR  -adobe-new century schoolbook-medium-r-normal--*-100
            -*-*-*-*-iso8859-1\n\
    NI  -adobe-new century schoolbook-medium-i-normal--*-100
            -*-*-*-*-iso8859-1\n\
    NB  -adobe-new century schoolbook-bold-r-normal--*-100
            -*-*-*-*-iso8859-1\n\
    NBI -adobe-new century schoolbook-bold-i-normal--*-100
            -*-*-*-*-iso8859-1\n\
    S   -adobe-symbol-medium-r-normal--*-100
            -*-*-*-*-adobe-fontspecific\n\
    SS  -adobe-symbol-medium-r-normal--*-100
            -*-*-*-*-adobe-fontspecific\n\

Options
-help and --help display a usage message, while -version and --version show version information; all exit afterward.

gxditview accepts all of the standard X Toolkit command-line options along with the additional options listed below.

-page
    This option specifies the page number of the document to be displayed.

-backingStore backing-store-type
    Because redisplay of the groff intermediate output window can take a perceiptible amount of time, this option causes the server to save the window contents so that when it is scrolled around the viewport, the window is painted from contents saved in backing store. backing-store-type can be one of Always, WhenMapped or NotUseful.

-printCommand command
    The default command displayed in the dialog box for the Print menu entry will be command.

-resolution res
    The groff intermediate output file will be displayed at a resolution of res dots per inch, unless the DESC file contains the X11 command, in which case the device resolution will be used. This corresponds to the Dvi widget's resolution resource. The default is 75.

-filename string
    The default filename displayed in the dialog box for the Open menu entry will be string. This can be either a filename, or a command starting with “|”.

The following standard X Toolkit command-line arguments are commonly used with gxditview.

-bg color
    This option specifies the color to use for the background of the window. The default is “white”.

-bd color
    This option specifies the color to use for the border of the window. The default is “black”.

-bw number
    This option specifies the width in pixels of the border surrounding the window.

-fg color
    This option specifies the color to use for displaying text. The default is “black”.

-fn font
    This option specifies the font to be used for displaying widget text. The default is “fixed”.

-rv This option indicates that reverse video should be simulated by swapping the foreground and background colors.

-geometry geometry
    This option specifies the preferred size and position of the window.

-display host:display
    This option specifies the X server to contact.

-xrm resourcestring
    This option specifies a resource string to be used.

Environment

GROFF_FONT_PATH
    A list of directories in which to seek the selected output device's directory of device and font description files. See gtroff(1) and groff_font(5).

Files

/usr/pkg/lib/X11/app-defaults/GXditview
/usr/pkg/lib/X11/app-defaults/GXditview-color
    define X application defaults for gxditview. Users can override these values in the .Xdefaults file, normally located in the user's home directory. See appres(1) and xrdb(1).

/usr/pkg/share/groff/1.23.0/font/devX100/DESC
    describes the X100 output device.

/usr/pkg/share/groff/1.23.0/font/devX100/F
    describes the font known as F on device X100.

/usr/pkg/share/groff/1.23.0/font/devX100-12/DESC
    describes the X100-12 output device.

/usr/pkg/share/groff/1.23.0/font/devX100-12/F
    describes the font known as F on device X100-12.

/usr/pkg/share/groff/1.23.0/font/devX75/DESC
    describes the X75 output device.

/usr/pkg/share/groff/1.23.0/font/devX75/F
    describes the font known as F on device X75.

/usr/pkg/share/groff/1.23.0/font/devX75-12/DESC
    describes the X75-12 output device.

/usr/pkg/share/groff/1.23.0/font/devX75-12/F
    describes the font known as F on device X75-12.

/usr/pkg/share/groff/1.23.0/tmac/X.tmac
    defines macros for use with the X100, X100-12, X75, and X75-12 output devices. It is automatically loaded by troffrc when any of those output devices is selected.

/usr/pkg/share/groff/1.23.0/tmac/Xps.tmac
    sets up gtroff to use gxditview as a previewer for device-independent output targeting the ps output device. It is automatically loaded by troffrc when gtroff is given the options -X and -Tps.

Examples
The following command views this man page with a base point size of 12.

        groff -TX100-12 -man gxditview.1

The quality of the result depends mainly on the chosen point size and display resolution; for rapid previewing, however, something like
        groff -X -P-resolution -P100 document
yields acceptable results.

Authors
gxditview and its predecessor xditview were written by Keith Packard (MIT X Consortium), Richard L. Hyde (Purdue), David Slattengren (Berkeley), Malcolm Slaney (Schlumberger Palo Alto Research), Mark Moraes (University of Toronto), and James Clark.

This program is derived from xditview; portions of xditview originated in xtroff, which was derived from suntroff.

See also
“X Logical Font Description Conventions” (https://www.x.org/releases/X11R7.6/doc/xorg-docs/specs/XLFD/xlfd.html), by Jim Flowers and Stephen Gildea.

X(7), xrdb(1), xditview(1), groff(1), groff_out(5)